<%@page import="com.pjt.cstore.CustomerVO"%>
<%@page import="com.pjt.cstore.CeoVO"%>
<%@page import="com.pjt.cstore.CeoDAO"%>
<%@page import="java.util.List"%>
<%@page import="com.pjt.cstore.CommunityVO"%>
<%@page import="java.util.ArrayList"%>
<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html lang="ko">

<%
	String ceo = (String) session.getAttribute("ceo");

	if (ceo == null) {
		response.sendRedirect("/");
	}

	CeoDAO ceoDAO = new CeoDAO();

	ArrayList<CustomerVO> customerList = ceoDAO.customerlist();
	List<CustomerVO> listing = null;
	
	
	// 페이지네이션 관련 소스
	final int ROWSIZE = 10; // 한페이지에 보일 게시물 수
	final int BLOCK = 5; // 아래에 보일 페이지 최대개수
	int pagecount = 0;
	
	if(customerList.size() != 0){
		pagecount = customerList.size()/ROWSIZE + 1; // 총 페이지 개수
		
		if(customerList.size()%ROWSIZE == 0) {
			pagecount -= 1;
		}
	}
	
	int listpage = 1; //기본 페이지값
	if (request.getParameter("page") != null) { //받아온 pg값이 있을때, 다른페이지일때
		listpage = Integer.parseInt(request.getParameter("page")); // pg값을 저
	}
	
	if(listpage != pagecount){
		listing = customerList.subList((listpage-1)*ROWSIZE, listpage*ROWSIZE);
	} else {
		listing = customerList.subList((listpage-1)*ROWSIZE, customerList.size());
	}
	
	int startPage = ((listpage-1)/BLOCK*BLOCK)+1;
	int endPage = ((listpage-1)/BLOCK*BLOCK)+BLOCK;
	
	if(endPage > pagecount) {
		endPage = pagecount;
	}
%>

<!-- Head 삽입 -->
<jsp:include page="/include/head.jsp" />

<body>

	<div id="page-wrapper">

		<!-- Header 삽입 -->
		<jsp:include page="/include/header.jsp" />

		<!-- Nav 삽입 -->
		<jsp:include page="/include/nav.jsp" />

		<!-- Main -->
		<section id="main" class="search">
			<div class="container">
				<div class="col-12">
					<div class="content">
						<article class="box page-content">
							<header>
								<h2>마일리지</h2>
							</header>
						</article>
					</div>
					<!-- Highlight -->
					<section class="box highlight search_box mgl50p">
						<table>
							<caption>커뮤니티 게시글 리스트</caption>
							<colgroup>
								<col width="20%" />
								<col width="20%" />
								<col width="" />
							</colgroup>
							<thead>
								<tr>
									<th>아이디</th>
									<th>보유 마일리지</th>
									<th>수정</th>
								</tr>
							</thead>
							<tbody>
								<%
									for (CustomerVO customer : listing) {
								%>
								<tr>
									<td><%=customer.getId()%></td>
									<td class="tleft"><%=customer.getMileage()%> POINT</td>
									<td>
										<input type="text" name="mileage" value="0">
										<button type="button" class="manage_btn" onclick="add_mileage('<%=customer.getId()%>')">추가</button>
										<button type="button" class="manage_btn" onclick="des_mileage('<%=customer.getId()%>')">감소</button>
									</td>
								</tr>
								<%
									}
								%>
							</tbody>
						</table>
						<ul class="pagination">
						<% if(listpage > BLOCK) { %>
							<li><a href="./customerManage.jsp?page=1">◀◀</a></li>
							<li><a href="./customerManage.jsp?page=<%=startPage-1%>">◀</a></li>
						<% } %>
						
						<% 
							for(int i = startPage; i <= endPage; i++) {
								if(i==listpage){
						%>
									<li class="current"><%=i%></li>
								<% } else { %>
									<li><a href="./customerManage.jsp?page=<%=i%>"><%=i%></a></li>
								<% } %>
						<% } %>
						
						
						<% if(endPage < pagecount) { %>
							<li><a href="./customerManage.jsp?page=<%=endPage+1%>">▶</a></li>
							<li><a href="./customerManage.jsp?page=<%=pagecount%>">▶▶</a></li>
						<% } %>
						</ul>
					</section>
				</div>

			</div>
		</section>

		<!-- Footer 삽입 -->
		<jsp:include page="/include/footer.jsp" />

	</div>
	<script>
		function add_mileage(id){
			if(confirm('정말 추가하시겠습니까?')){
				$.ajax({
					async : true,
					type : 'GET',
					url : "/CeoController?controller=addmileage&id="+id+"&mileage="+$("input[name=mileage]").val(),
					dataType : "text",
					contentType : "application/json; charset=UTF-8",
					success : function(data) {
						if (data == "success") {
							alert("마일리지가 정상적으로 지급되었습니다.");
							location.reload();
						} else {
							alert("마일리지 지급에 실패했습니다.");
						}
					}
				});
			}
		}
		
		function des_mileage(id){
			if(confirm('정말 감소하시겠습니까?')){
				$.ajax({
					async : true,
					type : 'GET',
					url : "/CeoController?controller=desmileage&id="+id+"&mileage="+$("input[name=mileage]").val(),
					dataType : "text",
					contentType : "application/json; charset=UTF-8",
					success : function(data) {
						if (data == "success") {
							alert("마일리지가 정상적으로 감소되었습니다.");
							location.reload();
						} else {
							alert("마일리지 감소에 실패했습니다.");
						}
					}
				});
			}
		}
	</script>
</body>

</html>