<%@page import="java.util.List"%>
<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@page import="com.pjt.cstore.CeoDAO"%>
<!DOCTYPE html>
<html lang="ko">

<!-- Head 삽입 -->
<jsp:include page="/include/head.jsp" />

<body>
	<%
		String ceo = (String) session.getAttribute("ceo");
		String user = (String)session.getAttribute("user");
	
		if (ceo == null) {
			response.sendRedirect("/");
		}
		
		CeoDAO ceodao = new CeoDAO();
		List<String> storelist = ceodao.getStoreName(user);
		
	%>
	<div id="page-wrapper">

		<!-- Header 삽입 -->
		<jsp:include page="/include/header.jsp" />

		<!-- Nav 삽입 -->
		<jsp:include page="/include/nav.jsp" />

		<!-- Main -->
		<section id="main">
			<div class="container">
				<div class="col-12">

					<div class="content">

						<!-- Content -->
						<article class="box page-content">

							<header>
								<h2>물품등록</h2>
							</header>

							<!-- Features -->
							<section class="box features">
								<div>
									<form action="/UploadProduct" method="POST" class="form join" id="uploadProductForm" enctype="multipart/form-data">
										<input type="hidden" name="owner" value="<%=user%>" class="col-6" required />
										<div class="row">
											<div class="col-12 row mgt05">
												<label for="store" class="col-3">매장 선택</label>
												<select id="store" name="store" class="col-6" required >
													<% for(String store : storelist) { %>
														<option><%=store%></option>
													<% } %>
												</select>
											</div>
											<div class="col-12 row mgt05">
												<label for="name" class="col-3">상품 이름</label> <input
													type="text" id="name" name="name" class="col-6"
													required />
											</div>
											<div class="col-12 row mgt05">
												<label for="img" class="col-3">상품 이미지</label>
												<div class="filebox col-9 row mg0 pd0">
													<input class="upload-name col-8" id="img" name="img" value="파일선택" disabled="disabled" multiple="multiple" required>
													<label class="col-2 mgl50p" for="ex_filename">업로드</label>
													<input type="file" id="ex_filename" name="ex_filename" class="upload-hidden" multiple="multiple">
												</div>
											</div>
											<div class="col-12 row mgt05">
												<label for="price" class="col-3">상품 가격</label> <input
													type="text" id="price" name="price" class="col-6"
													required />
											</div>

											<div class="col-12">
												<ul class="actions">
													<li><a href="javascript:history.back()"
														class="button alt">이전</a></li>
													<li><button type="button" onClick="submitJoin()"
															class="button">등록완료</button></li>
												</ul>
											</div>

										</div>
									</form>
								</div>
							</section>

						</article>

					</div>

				</div>
			</div>
		</section>

		<!-- Footer 삽입 -->
		<jsp:include page="/include/footer.jsp" />
		<script>
			$(document).ready(function() {
				var fileTarget = $('.filebox .upload-hidden'); fileTarget.on('change', function(){
					if(window.FileReader){ 
						var filename = $(this)[0].files[0].name;
					} else { 
						filename = $(this).val().split('/').pop().split('\\').pop();
					}
					
					$(this).siblings('.upload-name').val(filename);			
				});
			});

			function submitJoin() {

				/* 입력 검증 */
				if ($("#name").val() == "") {
					alert('상품 이름을 입력하세요.');
					return false;
				} else if ($("#img").val() == "파일선택") {
					alert('이미지 파일을 선택해주세요.');
					return false;
				} else if ($("#price").val() == "") {
					alert('가격을 입력해주세요.');
					return false;
				}
				
				/* 가격 입력 정규식 검증 */
				var regExp = /[^0-9]/;
				
				if (regExp.test($("#price").val())) {
					alert('가격은 숫자만 입력해주세요.');
					return false;
				}
				
				$("#uploadProductForm").submit();
			}
		</script>
	</div>
</body>

</html>