<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html lang="ko">

<%
	String ceo = (String) session.getAttribute("ceo");
	String id = (String) session.getAttribute("user");

	if (ceo == null) {
		response.sendRedirect("/");
	}
%>

<!-- Head 삽입 -->
<jsp:include page="/include/head.jsp" />

<body>

	<div class="dim">
		<div id="storeMap"></div>
	</div>
	<div id="page-wrapper">

		<!-- Header 삽입 -->
		<jsp:include page="/include/header.jsp" />

		<!-- Nav 삽입 -->
		<jsp:include page="/include/nav.jsp" />

		<!-- Main -->
		<section id="main">
			<div class="container">
				<div class="col-12">

					<div class="content">

						<!-- Content -->
						<article class="box page-content">

							<header>
								<h2>점포 등록</h2>
							</header>

							<!-- Features -->
							<section class="box features">
								<div>
									<form action="/StoreJoin" method="POST" class="form join"
										id="joinform">
										<div class="row">
											<div class="col-12 row mgt05">
												<label for="storeName" class="col-3">점포명</label> <input
													type="text" id="storeName" name="storeName" class="col-6" required />
											</div>
											<div class="col-12 row mgt05">
												<label for="storeAddress" class="col-3">점포 주소</label> <input
													type="text" id="storeAddress" name="storeAddress" class="col-6" placeholder="ex: 제주특별자치도 제주시 첨단로 242"
													required />
												<button type="button" onClick="locationCheck()"
													class="button col-2 right">위치 확인</button>
												<input type="hidden" name="locChecker" value="unCheck">
											</div>
											<div class="col-12 row mgt05">
												<label for="storeCall" class="col-3">점포 연락처</label> <input
													type="text" id="storeCall" name="storeCall"
													class="col-6" required />
											</div>
											<div class="col-12">
												<ul class="actions">
													<li><a href="javascript:history.back()"
														class="button alt">이전</a></li>
													<li><button type="button" onClick="submitJoin()"
															class="button">등록 완료</button></li>
												</ul>
											</div>

										</div>
									</form>
								</div>
							</section>

						</article>

					</div>

				</div>
			</div>
		</section>

		<!-- Footer 삽입 -->
		<jsp:include page="/include/footer.jsp" />
		<script>
			$('.dim').click(function(e) {
				$('.dim').css('display', 'none');
			});

			function locationCheck() {
				$('.dim').css('display', 'block');
				var mapContainer = document.getElementById('storeMap'), // 지도를 표시할 div 
				mapOption = {
					center : new kakao.maps.LatLng(33.450701, 126.570667), // 지도의 중심좌표
					level : 3
				// 지도의 확대 레벨
				};

				// 지도를 생성합니다    
				var map = new kakao.maps.Map(mapContainer, mapOption);

				// 주소-좌표 변환 객체를 생성합니다
				var geocoder = new kakao.maps.services.Geocoder();

				// 주소로 좌표를 검색합니다
				geocoder
						.addressSearch(
								$("#storeAddress").val(),
								function(result, status) {

									// 정상적으로 검색이 완료됐으면 
									if (status === kakao.maps.services.Status.OK) {

										var coords = new kakao.maps.LatLng(
												result[0].y, result[0].x);

										// 결과값으로 받은 위치를 마커로 표시합니다
										var marker = new kakao.maps.Marker({
											map : map,
											position : coords
										});

										// 인포윈도우로 장소에 대한 설명을 표시합니다
										var infowindow = new kakao.maps.InfoWindow(
												{
													content : '<div style="width:150px;text-align:center;padding:6px 0;">'+$('input[name=storeName]').val()+'</div>'
												});
										infowindow.open(map, marker);

										// 지도의 중심을 결과값으로 받은 위치로 이동시킵니다
										map.setCenter(coords);
										$('input[name=locChecker]').val("check");
									}
									
									
								});

			}

			function submitJoin() {

				/* 입력 검증 */
				if ($("#storeName").val() == "") {
					alert('점포명을 입력하세요.');
					return false;
				} else if ($("#storeAddress").val() == "") {
					alert('점포 주소를 입력하세요.');
					return false;
				} else if ($("#storeCall").val() == "") {
					alert('점포 연락처를 입력하세요.');
					return false;
				}

				/* 점포 위치 확인 검증 */
				if ($('input[name=locChecker]').val() != "check") {
					alert('점포 위치 확인을 해주세요.');
					return false;
				}
				
				$('.join').append($('<input name="owner" id="owner" style="display:none"/>').val('<%=id%>'));
				
				$("#joinform").submit();
			}
		</script>
	</div>
</body>

</html>