package com.pjt.cstore;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import com.pjt.cstore.common.DBConnector;

public class CeoDAO {

	private Connection con;

	private PreparedStatement pstmt;

	private ResultSet rs,rs2,rs3;

	public CeoDAO() {

		try {

			DBConnector connector = new DBConnector();
			con = connector.DBCon();

		} catch (Exception e) {

			e.printStackTrace();

		}

	}

	public int login(String id, String password) {

		String SQL = "SELECT password FROM ceo_info WHERE id = ?";

		try {

			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, id);
			rs = pstmt.executeQuery();

			if (rs.next()) {
				if (rs.getString(1).equals(password)) {
					return 1;
				} else {
					return 0;
				}
			}

			return -1;

		} catch (Exception e) {

			e.printStackTrace();

		}

		return -2;
	}

	public int join(CeoVO ceoVO) {

		String SQL = "INSERT INTO ceo_info (id,password,phone,name) VALUES (?,?,?,?)";

		try {

			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, ceoVO.getId());
			pstmt.setString(2, ceoVO.getPassword());
			pstmt.setString(3, ceoVO.getPhone());
			pstmt.setString(4, ceoVO.getName());
			return pstmt.executeUpdate();

		} catch (Exception e) {

			e.printStackTrace();

		}

		return -1;
	}
	
	public ArrayList<CustomerVO> orderlist(String ceo) {
		ArrayList<CustomerVO> orderList = new ArrayList<CustomerVO>(); 

		try {
			String SQL = "SELECT * FROM paymentlist";
			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();

			while (rs.next()) {
				CustomerVO customerVO = new CustomerVO();
				SQL = "SELECT * FROM store WHERE code = ? AND store_owner = ?";
				pstmt = con.prepareStatement(SQL);
				pstmt.setInt(1, rs.getInt("store_code"));
				pstmt.setString(2, ceo);
				rs2 = pstmt.executeQuery();
				
				if(rs2.next()) {
					SQL = "SELECT * FROM product WHERE code = ?";
					pstmt = con.prepareStatement(SQL);
					pstmt.setInt(1, rs.getInt("product_code"));
					rs3 = pstmt.executeQuery();
					
					if(rs3.next()) {
						customerVO.setName(rs.getString("name"));
						customerVO.setOrderProduct(rs3.getString("name"));
						customerVO.setOrderCount(rs.getInt("count"));
						if(rs3.getInt("sale") == 1) {
							customerVO.setOrderPrice(rs.getInt("count") * (rs3.getInt("price")-rs3.getInt("saleprice")));
						} else {
							customerVO.setOrderPrice(rs.getInt("count") * rs3.getInt("price"));
						}
						orderList.add(customerVO);
					}
					
				}
			}

			return orderList;

		} catch (Exception e) {

			e.printStackTrace();

		}
		
		return orderList;
	}
	
	public ArrayList<StoreVO> proceedlist(String ceo) {
		ArrayList<StoreVO> proceedList = new ArrayList<StoreVO>();
		
		try {
			String SQL = "SELECT store_code FROM paymentlist GROUP BY store_code";
			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();
			
			while (rs.next()) {
				int price = 0;
				StoreVO storeVO = new StoreVO();
				SQL = "SELECT * FROM store WHERE code = ? AND store_owner = ?";
				pstmt = con.prepareStatement(SQL);
				pstmt.setInt(1, rs.getInt("store_code"));
				pstmt.setString(2, ceo);
				rs2 = pstmt.executeQuery();
				
				if(rs2.next()) {
					SQL = "SELECT * FROM paymentlist WHERE store_code = ?";
					pstmt = con.prepareStatement(SQL);
					pstmt.setInt(1, rs.getInt("store_code"));
					rs3 = pstmt.executeQuery();
					
					while(rs3.next()) {
						price += rs3.getInt("price");
					}
					storeVO.setName(rs2.getString("store_name"));
					storeVO.setPrice(price);
					proceedList.add(storeVO);
				}
			}

			return proceedList;

		} catch (Exception e) {

			e.printStackTrace();

		}
		
		return proceedList;
	}	

	
	public ArrayList<CustomerVO> customerlist() {
		ArrayList<CustomerVO> customerList = new ArrayList<CustomerVO>(); 

		try {
			String SQL = "SELECT * FROM customer_info";
			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();

			while (rs.next()) {
				CustomerVO customerVO = new CustomerVO();
				customerVO.setId(rs.getString("id"));
				customerVO.setName(rs.getString("name"));
				customerVO.setMileage(rs.getInt("mileage"));
				customerVO.setPhone(rs.getString("phone"));
				customerVO.setAddress(rs.getString("address"));
				
				customerList.add(customerVO);
			}

			return customerList;

		} catch (Exception e) {

			e.printStackTrace();

		}
		
		return customerList;
	}
	
	public int addMileage(String id, int mileage) {
		try {
			String SQL = "SELECT * FROM customer_info WHERE id = ?";
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, id);
			rs = pstmt.executeQuery();
			
			while (rs.next()) {
				SQL = "UPDATE customer_info SET mileage = ? WHERE id = ?";
				pstmt = con.prepareStatement(SQL);
				pstmt.setInt(1, rs.getInt("mileage") + mileage);
				pstmt.setString(2, id);
				
				return pstmt.executeUpdate();
			}

			return -1;

		} catch (Exception e) {
			e.printStackTrace();
		}
		return -1;
	}
	
	public int desMileage(String id, int mileage) {
		try {
			String SQL = "SELECT * FROM customer_info WHERE id = ?";
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, id);
			rs = pstmt.executeQuery();
			while (rs.next()) {
				SQL = "UPDATE customer_info SET mileage = ? WHERE id = ?";
				pstmt = con.prepareStatement(SQL);
				pstmt.setInt(1, rs.getInt("mileage") - mileage);
				pstmt.setString(2, id);
				
				return pstmt.executeUpdate();
			}

			return -1;

		} catch (Exception e) {
			e.printStackTrace();
		}
		return -1;
	}
	
	public int getStoreCount(String id) {
		try {
			String SQL = "SELECT * FROM store WHERE store_owner = ?";
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, id);
			rs = pstmt.executeQuery();
			while (rs.next()) {
				return 1;
			}

			return -1;

		} catch (Exception e) {
			e.printStackTrace();
		}
		return -1;
	}
	
	public int insertProduct(String store,String name,String img,int price,String owner) {

		String SQL = "SELECT AUTO_INCREMENT FROM information_schema.tables WHERE table_name = 'product' AND table_schema = DATABASE()";
		try {
			
			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();
			
			SQL = "INSERT INTO product (name,price,img,code) VALUES (?,?,?,?)";
			
			while(rs.next()) {
				pstmt = con.prepareStatement(SQL);
				pstmt.setString(1, name);
				pstmt.setInt(2, price);
				pstmt.setString(3, img);
				pstmt.setInt(4, rs.getInt("AUTO_INCREMENT")*100);
				pstmt.executeUpdate();
				
				SQL = "SELECT * FROM store WHERE store_name = ? AND store_owner = ?";
				pstmt = con.prepareStatement(SQL);
				pstmt.setString(1, store);
				pstmt.setString(2, owner);
				rs2 = pstmt.executeQuery();
				
				SQL = "INSERT INTO store_product (store_code,product_code,set_code) VALUES (?,?,?)";
				while(rs2.next()) {
					pstmt = con.prepareStatement(SQL);
					pstmt.setInt(1, rs2.getInt("code"));
					pstmt.setInt(2, rs.getInt("AUTO_INCREMENT")*100);
					pstmt.setString(3, rs2.getInt("code")+"s"+rs.getInt("AUTO_INCREMENT")*100+"p");
					return pstmt.executeUpdate();
				}
			}
			
		} catch (Exception e) {

			e.printStackTrace();

		}

		return -1;
	}
	
	public List<String> getStoreName(String id) {
		List<String> storeList = new ArrayList<String>();
		
		try {
			String SQL = "SELECT * FROM store WHERE store_owner = ?";
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, id);
			rs = pstmt.executeQuery();
			while (rs.next()) {
				storeList.add(rs.getString("store_name"));
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return storeList;
	}
}
