package com.pjt.cstore;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;

import com.pjt.cstore.common.DBConnector;

public class CommunityDAO {
	private Connection con;

	private PreparedStatement pstmt;

	private ResultSet rs;

	public CommunityDAO() {

		try {

			DBConnector connector = new DBConnector();
			con = connector.DBCon();

		} catch (Exception e) {

			e.printStackTrace();

		}

	}

	public int write(CommunityVO communityVO) {
		String SQL = "";
		int ref = 0;

		SQL = "SELECT AUTO_INCREMENT FROM information_schema.tables	WHERE TABLE_NAME = 'community_board' AND table_schema = DATABASE( )";
		try {

			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();

			if(rs.next()) {
				ref = rs.getInt(1);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		SQL = "INSERT INTO community_board (title,content,author,board_ref) VALUES (?,?,?,?)";

		try {
			
			String content_replace = communityVO.getContent().replace("\r\n","<br>");
			
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, communityVO.getTitle());
			pstmt.setString(2, content_replace);
			pstmt.setString(3, communityVO.getAuthor());
			pstmt.setInt(4, ref);
			return pstmt.executeUpdate();

		} catch (Exception e) {

			e.printStackTrace();

		}

		return -1;
	}
	
	public ArrayList<CommunityVO> list() {
		String SQL = "";
		ArrayList<CommunityVO> communityList = new ArrayList<CommunityVO>();

		SQL = "SELECT idx,title,author,date FROM community_board ORDER BY board_ref DESC, board_step ASC";
		try {

			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();

			while(rs.next()) {
				CommunityVO communityVO = new CommunityVO();
				communityVO.setIdx(rs.getInt("idx"));
				communityVO.setTitle(rs.getString("title"));
				communityVO.setAuthor(rs.getString("author"));
				communityVO.setDate(rs.getDate("date"));
				
				communityList.add(communityVO);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return communityList;
	}
	

	
	public CommunityVO detail(String idx) {
		String SQL = "";
		CommunityVO communityVO = new CommunityVO();

		SQL = "SELECT * FROM community_board WHERE idx = '" + idx + "'";
		try {

			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();

			while(rs.next()) {
				communityVO.setIdx(rs.getInt("idx"));
				communityVO.setTitle(rs.getString("title"));
				communityVO.setAuthor(rs.getString("author"));
				communityVO.setContent(rs.getString("content"));
				communityVO.setDate(rs.getDate("date"));
				communityVO.setBoard_ref(rs.getInt("board_ref"));
				communityVO.setBoard_step(rs.getInt("board_step"));
				communityVO.setBoard_level(rs.getInt("board_level"));
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return communityVO;
	}
	
	public int delete(String idx) {
		String SQL = "";

		SQL = "DELETE FROM community_board WHERE idx = (?)";
		try {

			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, idx);
			return pstmt.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return -1;
	}
	
	public int update(CommunityVO communityVO) {
		String SQL = "";

		SQL = "UPDATE community_board SET title = (?), content = (?) WHERE idx = '" + communityVO.getIdx() + "'";
		try {
			
			String content_replace = communityVO.getContent().replace("\r\n","<br>");
			
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, communityVO.getTitle());
			pstmt.setString(2, content_replace);
			return pstmt.executeUpdate();
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		return -1;
	}
	
	public int reply(CommunityVO communityVO) {
		String SQL = "";

		SQL = "UPDATE community_board SET board_step = board_step + 1 WHERE board_ref = (?) and board_step > (?)";
		try {
			pstmt = con.prepareStatement(SQL);
			pstmt.setInt(1, communityVO.getBoard_ref());
			pstmt.setInt(2, communityVO.getBoard_step());
			pstmt.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
		}

		SQL = "INSERT INTO community_board (title,content,author,board_ref,board_step,board_level) VALUES (?,?,?,?,?,?)";
		try {
			
			String content_replace = communityVO.getContent().replace("\r\n","<br>");
			
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, communityVO.getTitle());
			pstmt.setString(2, content_replace);
			pstmt.setString(3, communityVO.getAuthor());
			pstmt.setInt(4, communityVO.getBoard_ref());
			pstmt.setInt(5, communityVO.getBoard_step()+1);
			pstmt.setInt(6, communityVO.getBoard_level()+1);
			pstmt.executeUpdate();
			
			return 1;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return -1;
	}


}
