package com.pjt.cstore;

import java.math.BigInteger;
import java.security.MessageDigest;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

import com.pjt.cstore.common.DBConnector;

public class CustomerDAO {

	private Connection con;

	private PreparedStatement pstmt;

	private ResultSet rs;

	public CustomerDAO() {

		try {
			
			DBConnector connector = new DBConnector();
			con = connector.DBCon();
			
		} catch (Exception e) {

			e.printStackTrace();

		}

	}

	public int login(String id, MessageDigest password) {

		String SQL = "SELECT password FROM customer_info WHERE id = ?";

		try {
			
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, id);
			rs = pstmt.executeQuery();
			
			if (rs.next()) {
				if (rs.getString(1).equals(new BigInteger(1, password.digest()).toString(16))) {
					return 1;
				} else {
					return 0;
				}
			}
			
			return -1;
			
		} catch (Exception e) {
			
			e.printStackTrace();
			
		}
		
		return -2;
	}
	
	public int join(CustomerVO customerVO) {

		String SQL = "INSERT INTO customer_info (id,password,phone,adult,address,name) VALUES (?,?,?,?,?,?)";

		try {
			
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, customerVO.getId());
			pstmt.setString(2, customerVO.getPassword());
			pstmt.setString(3, customerVO.getPhone());
			pstmt.setInt(4, customerVO.getAdult());
			pstmt.setString(5, customerVO.getAddress());
			pstmt.setString(6, customerVO.getName());
			return pstmt.executeUpdate();
			
		} catch (Exception e) {
			
			e.printStackTrace();
			
		}
		
		return -1;
	}
	
	public CustomerVO searchAll(String id) {
		
		CustomerVO customerVO = new CustomerVO();
		String SQL = "SELECT * FROM customer_info WHERE id = ?";

		try {
			
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, id);
			rs = pstmt.executeQuery();
			
			if (rs.next()) {
				customerVO.setAddress(rs.getString("address"));
				customerVO.setAdult(rs.getInt("adult"));
				customerVO.setId(rs.getString("id"));
				customerVO.setMileage(rs.getInt("mileage"));
				customerVO.setName(rs.getString("name"));
				customerVO.setPhone(rs.getString("phone"));
			}
			
		} catch (Exception e) {
			
			e.printStackTrace();
			
		}
		
		return customerVO;
	}
	
	public int delete(String id) {
		String SQL = "DELETE FROM customer_info WHERE id = (?)";

		try {
			
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, id);
			pstmt.executeUpdate();
			return 1;
		} catch (Exception e) {
			
			e.printStackTrace();
			
		}
		
		return -1;
	}
}