package com.pjt.cstore;

import java.io.IOException;
import java.io.PrintWriter;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;

import javax.crypto.BadPaddingException;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.pjt.cstore.common.CipherUtil;


@WebServlet("/CustomerJoin")
public class CustomerJoin extends HttpServlet {
	private static final long serialVersionUID = 1L;

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		// TODO Auto-generated method stub
		response.getWriter().append("Served at: ").append(request.getContextPath());
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		// TODO Auto-generated method stub
		response.setContentType("text/html;charset=utf-8");
		request.setCharacterEncoding("utf-8");
		
		String name = "";
		String id = "";
		String password = "";
		String phone = "";
		String address = "";
		int adult = 0;
		int result = 0;
		
		HttpSession session = request.getSession();
		PrivateKey privateKey = (PrivateKey)session.getAttribute("privateKey");

		
		
		try {
			name = CipherUtil.decryptRSA(request.getParameter("name"), privateKey);
			id = CipherUtil.decryptRSA(request.getParameter("join_id"), privateKey);
			password = request.getParameter("join_password");
			phone = CipherUtil.decryptRSA(request.getParameter("phone"), privateKey);
			address = CipherUtil.decryptRSA(request.getParameter("address"), privateKey) + " " + CipherUtil.decryptRSA(request.getParameter("detail_address"), privateKey);
			adult = Integer.parseInt(request.getParameter("adult"));
		} catch (InvalidKeyException | NoSuchPaddingException | NoSuchAlgorithmException | BadPaddingException
				| IllegalBlockSizeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//
		if(!(name.equals("") || id.equals("") || password.equals("") || phone.equals("") || address.equals(""))) {
			CustomerDAO customerDAO = new CustomerDAO();
			CustomerVO customerVO = new CustomerVO();
			
			customerVO.setName(name);
			customerVO.setId(id);
			customerVO.setPassword(password);
			customerVO.setPhone(phone);
			customerVO.setAddress(address);
			customerVO.setAdult(adult);
			
			result = customerDAO.join(customerVO);
			
			if(result > 0) {
				PrintWriter out = response.getWriter();
				out.println("회원가입 완료");
			} else {
				System.out.println("DB 입력 실패");
			}
		} else {
			PrintWriter out = response.getWriter();
			out.println("입력값에 오류가 있습니다.");
			
		}
		
	}

}
