package com.pjt.cstore;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;

import com.pjt.cstore.common.DBConnector;

public class PurchaseDAO {

	private Connection con;

	private PreparedStatement pstmt;

	private ResultSet rs, rs2, rs3;

	public PurchaseDAO() {

		try {

			DBConnector connector = new DBConnector();
			con = connector.DBCon();

		} catch (Exception e) {

			e.printStackTrace();

		}

	}

	public int setBasketPurchase(String SQLitem) {
		String SQL = "";
		PurchaseVO purchaseVO = new PurchaseVO();
		SQL = "SELECT * FROM basket WHERE "+SQLitem;
		try {
			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();
			
			while(rs.next()) {
				purchaseVO.setCount(rs.getInt("count"));
				purchaseVO.setProduct_code(rs.getInt("code"));
				purchaseVO.setName(rs.getString("user"));
				
				SQL =  "SELECT store_code FROM store_product WHERE set_code = ?";
				pstmt = con.prepareStatement(SQL);
				pstmt.setString(1, rs.getString("set_code"));
				rs2 = pstmt.executeQuery();
				if(rs2.next()) {purchaseVO.setStore_code(rs2.getInt("store_code"));}
				
				SQL =  "INSERT INTO purchaselist (product_code,store_code,count,name) VALUES (?,?,?,?)";
				pstmt = con.prepareStatement(SQL);
				pstmt.setInt(1, purchaseVO.getProduct_code());
				pstmt.setInt(2, purchaseVO.getStore_code());
				pstmt.setInt(3, purchaseVO.getCount());
				pstmt.setString(4, purchaseVO.getName());
				pstmt.executeUpdate();
			}
			
			return 1;
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		return -1;
	}
	
	public ArrayList<PurchaseVO> getList(String name) {
		String SQL = "";
		ArrayList<PurchaseVO> purchaseList = new ArrayList<PurchaseVO>();
		
		SQL = "SELECT * FROM purchaselist WHERE name = ?";
		try {
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, name);
			rs = pstmt.executeQuery();
			
			while(rs.next()) {
				PurchaseVO purchaseVO = new PurchaseVO();
				purchaseVO.setCount(rs.getInt("count"));
				purchaseVO.setName(rs.getString("name"));
				purchaseVO.setProduct_code(rs.getInt("product_code"));
				purchaseVO.setStore_code(rs.getInt("store_code"));
				purchaseVO.setIdx(rs.getInt("idx"));
				
				purchaseList.add(purchaseVO);
			}
			
			return purchaseList;
		} catch (Exception e) {
			// TODO: handle exception
		}
		
		return purchaseList;
	}
	
	public int resetPurchase(String name) {
		String SQL = "";
		
		SQL = "DELETE FROM purchaselist WHERE name = ?";
		try {
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, name);
			pstmt.executeUpdate();
			
			return 1;
		} catch (Exception e) {
			// TODO: handle exception
		}
		return 0;
	}
	
	public int deletePurchase(String user, String pcode) {
		String SQL = "";
		
		SQL = "DELETE FROM purchaselist WHERE name = ? AND " + pcode;
		
		try {

			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, user);
			return pstmt.executeUpdate();
			
		} catch (Exception e) {

			e.printStackTrace();

		}
		
		return -1;
	}
	
	public int purchaseItem(String SQLitem, int price) {
		String SQL = "";
		
		SQL = "SELECT * FROM purchaselist WHERE "+SQLitem;
		try {
			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();
			
			while(rs.next()) {
				SQL =  "INSERT INTO paymentlist (product_code,store_code,count,name,price) VALUES (?,?,?,?,?)";
				pstmt = con.prepareStatement(SQL);
				pstmt.setInt(1, rs.getInt("product_code"));
				pstmt.setInt(2, rs.getInt("store_code"));
				pstmt.setInt(3, rs.getInt("count"));
				pstmt.setString(4,rs.getString("name"));
				pstmt.setInt(5,price);
				pstmt.executeUpdate();
			}
			
			return 1;
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return 0;
	}
	
	public int purchaseItemEach(String code, String count, String user, int price) {
		String SQL = "";
		
		SQL = "SELECT * FROM store_product WHERE set_code = ?";
		try {
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, code);
			rs = pstmt.executeQuery();
			
			while(rs.next()) {
				
				SQL =  "INSERT INTO paymentlist (product_code,store_code,count,name,price) VALUES (?,?,?,?,?)";
				pstmt = con.prepareStatement(SQL);
				pstmt.setInt(1, rs.getInt("product_code"));
				pstmt.setInt(2, rs.getInt("store_code"));
				pstmt.setString(3, count);
				pstmt.setString(4, user);
				pstmt.setInt(5, price);
				pstmt.executeUpdate();
			}
			
			return 1;
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		return 0;
	}
	
	public int payment(int price, String user) {
		String SQL = "";
		
		SQL = "SELECT * FROM customer_info WHERE id = ?";
		try {
			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, user);
			rs = pstmt.executeQuery();
			
			while(rs.next()) {
				if(rs.getInt("mileage") > price) {
					SQL =  "UPDATE customer_info SET mileage = ? WHERE id = ?";
					pstmt = con.prepareStatement(SQL);
					pstmt.setInt(1, rs.getInt("mileage") - price);
					pstmt.setString(2, user);
					return pstmt.executeUpdate();
				}
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		return 0;
	}
}
