package com.pjt.cstore;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;

import com.pjt.cstore.common.DBConnector;

public class StoreDAO {

	private Connection con, con2;

	private PreparedStatement pstmt, pstmt2;

	private ResultSet rs, rs2;

	public StoreDAO() {

		try {

			DBConnector connector = new DBConnector();
			con = connector.DBCon();
			con2 = connector.DBCon();

		} catch (Exception e) {

			e.printStackTrace();

		}

	}

	public int join(StoreVO storeVO) {
		String SQL = "";
		int ref = 0;

		SQL = "SELECT AUTO_INCREMENT FROM information_schema.tables	WHERE TABLE_NAME = 'store' AND table_schema = DATABASE( )";
		try {

			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();

			if (rs.next()) {
				ref = rs.getInt(1);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		SQL = "INSERT INTO store (store_owner,store_name,store_address,store_call,code) VALUES (?,?,?,?,?)";

		try {

			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, storeVO.getOwner());
			pstmt.setString(2, storeVO.getName());
			pstmt.setString(3, storeVO.getAddress());
			pstmt.setString(4, storeVO.getCall());
			pstmt.setInt(5, ref * 100);
			return pstmt.executeUpdate();

		} catch (Exception e) {

			e.printStackTrace();

		}

		return -1;
	}

	public ArrayList<StoreVO> list() {
		String SQL = "";
		ArrayList<StoreVO> storeList = new ArrayList<StoreVO>();

		SQL = "SELECT * FROM store ORDER BY store_name ASC";
		try {

			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();

			while (rs.next()) {
				StoreVO storeVO = new StoreVO();
				storeVO.setName(rs.getString("store_name"));
				storeVO.setAddress(rs.getString("store_address"));
				storeVO.setCode(rs.getInt("code"));
				storeVO.setFavorite(0);

				storeList.add(storeVO);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return storeList;
	}

	public ArrayList<StoreVO> customerlist(String user) {
		String SQL = "", SQL2 = "";
		ArrayList<StoreVO> storeList = new ArrayList<StoreVO>();

		SQL = "SELECT * FROM store ORDER BY store_name ASC";
		try {

			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();

			while (rs.next()) {
				StoreVO storeVO = new StoreVO();
				storeVO.setName(rs.getString("store_name"));
				storeVO.setAddress(rs.getString("store_address"));
				storeVO.setCode(rs.getInt("code"));

				SQL2 = "SELECT EXISTS (SELECT * FROM favorite_store WHERE name = '" + user + "' AND store_code = "
						+ rs.getInt("code") + ") AS success";
				pstmt2 = con2.prepareStatement(SQL2);
				rs2 = pstmt2.executeQuery();

				while (rs2.next()) {
					storeVO.setFavorite(rs2.getInt("success"));
				}

				storeList.add(storeVO);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return storeList;
	}

	public int savefavorite(String user, String code) {
		String SQL = "";

		SQL = "INSERT INTO favorite_store (name, store_code) VALUES (?,?)";

		try {

			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, user);
			pstmt.setString(2, code);
			return pstmt.executeUpdate();

		} catch (Exception e) {

			e.printStackTrace();

		}

		return -1;
	}

	public int unsavefavorite(String user, String code) {
		String SQL = "";

		SQL = "DELETE FROM favorite_store WHERE name = ? AND store_code = ?";

		try {

			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, user);
			pstmt.setString(2, code);
			return pstmt.executeUpdate();

		} catch (Exception e) {

			e.printStackTrace();

		}

		return -1;
	}

	public ArrayList<StoreVO> favoritelist(String user) {
		String SQL = "", SQL2 = "";
		ArrayList<StoreVO> storeList = new ArrayList<StoreVO>();
		ArrayList<StoreVO> storeList2 = new ArrayList<StoreVO>();
		ArrayList<StoreVO> storeList_sum = new ArrayList<StoreVO>();

		SQL = "SELECT * FROM store ORDER BY store_name ASC";
		try {

			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();

			while (rs.next()) {
				StoreVO storeVO = new StoreVO();
				storeVO.setName(rs.getString("store_name"));
				storeVO.setAddress(rs.getString("store_address"));
				storeVO.setCode(rs.getInt("code"));

				SQL2 = "SELECT EXISTS (SELECT * FROM favorite_store WHERE name = '" + user + "' AND store_code = "
						+ rs.getInt("code") + ") AS success";
				pstmt2 = con2.prepareStatement(SQL2);
				rs2 = pstmt2.executeQuery();

				while (rs2.next()) {
					storeVO.setFavorite(rs2.getInt("success"));
					if (rs2.getInt("success") == 0) {
						storeList.add(storeVO);
					} else {
						storeList2.add(storeVO);
					}
				}
			}

			storeList_sum.addAll(storeList2);
			storeList_sum.addAll(storeList);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return storeList_sum;
	}

	public ArrayList<StoreVO> onlyfavoritelist(String user) {
		String SQL = "", SQL2 = "";
		ArrayList<StoreVO> storeList = new ArrayList<StoreVO>();
		ArrayList<StoreVO> storeList_sum = new ArrayList<StoreVO>();

		SQL = "SELECT * FROM store ORDER BY store_name ASC";
		try {

			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();

			while (rs.next()) {
				StoreVO storeVO = new StoreVO();
				storeVO.setName(rs.getString("store_name"));
				storeVO.setAddress(rs.getString("store_address"));
				storeVO.setCode(rs.getInt("code"));

				SQL2 = "SELECT EXISTS (SELECT * FROM favorite_store WHERE name = '" + user + "' AND store_code = "
						+ rs.getInt("code") + ") AS success";
				pstmt2 = con2.prepareStatement(SQL2);
				rs2 = pstmt2.executeQuery();

				while (rs2.next()) {
					storeVO.setFavorite(rs2.getInt("success"));
					if (rs2.getInt("success") != 0) {
						storeList.add(storeVO);
					}
				}
			}
			
			storeList_sum.addAll(storeList);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return storeList_sum;
	}

	public StoreVO favoritestore(String user) {
		String SQL = "", SQL2 = "";
		StoreVO storeVO = null;
		SQL = "SELECT * FROM store ORDER BY store_name ASC";
		try {

			pstmt = con.prepareStatement(SQL);
			rs = pstmt.executeQuery();

			while (rs.next()) {
				storeVO = new StoreVO();
				storeVO.setName(rs.getString("store_name"));
				storeVO.setAddress(rs.getString("store_address"));
				storeVO.setCode(rs.getInt("code"));

				SQL2 = "SELECT EXISTS (SELECT * FROM favorite_store WHERE name = ? AND store_code = ?) AS success";
				pstmt2 = con2.prepareStatement(SQL2);
				pstmt2.setString(1, user);
				pstmt2.setInt(2, storeVO.getCode());
				rs2 = pstmt2.executeQuery();

				while (rs2.next()) {
					storeVO.setFavorite(rs2.getInt("success"));
					if (rs2.getInt("success") == 1) {
						return storeVO;
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return storeVO;
	}

	public ArrayList<StoreVO> searchStore(String search, String user) {
		String SQL = "", SQL2 = "";
		ArrayList<StoreVO> storeList = new ArrayList<StoreVO>();
		ArrayList<StoreVO> storeList_sum = new ArrayList<StoreVO>();

		SQL = "SELECT * FROM store WHERE store_name LIKE ? ORDER BY store_name ASC";
		try {

			pstmt = con.prepareStatement(SQL);
			pstmt.setString(1, "%"+search+"%");
			rs = pstmt.executeQuery();

			while (rs.next()) {
				StoreVO storeVO = new StoreVO();
				storeVO.setName(rs.getString("store_name"));
				storeVO.setAddress(rs.getString("store_address"));
				storeVO.setCode(rs.getInt("code"));
				if(user != null) {
					SQL2 = "SELECT EXISTS (SELECT * FROM favorite_store WHERE name = '" + user + "' AND store_code = "
							+ rs.getInt("code") + ") AS success";
					pstmt2 = con2.prepareStatement(SQL2);
					rs2 = pstmt2.executeQuery();
	
					while (rs2.next()) {
						storeVO.setFavorite(rs2.getInt("success"));
					}
				} else {
					storeVO.setFavorite(0);
				}
				storeList.add(storeVO);
			}
			
			storeList_sum.addAll(storeList);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return storeList_sum;
	}
}
