<%@page import="java.util.List"%>
<%@page import="com.pjt.cstore.CommunityDAO"%>
<%@page import="com.pjt.cstore.CommunityVO"%>
<%@page import="java.util.ArrayList"%>
<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html lang="ko">

<%
	String ceo = (String) session.getAttribute("ceo");
	String user = (String) session.getAttribute("user");
	if (ceo == null && user == null) {
		response.sendRedirect("/");
	}

	CommunityDAO communityDAO = new CommunityDAO();

	ArrayList<CommunityVO> communityList = communityDAO.list();
	List<CommunityVO> listing = null;
	
	
	// 페이지네이션 관련 소스
	final int ROWSIZE = 10; // 한페이지에 보일 게시물 수
	final int BLOCK = 5; // 아래에 보일 페이지 최대개수
	int pagecount = 0;
	
	if(communityList.size() != 0){
		pagecount = communityList.size()/ROWSIZE + 1; // 총 페이지 개수
		
		if(communityList.size()%ROWSIZE == 0) {
			pagecount -= 1;
		}
	}
	
	int listpage = 1; //기본 페이지값
	if (request.getParameter("page") != null) { //받아온 pg값이 있을때, 다른페이지일때
		listpage = Integer.parseInt(request.getParameter("page")); // pg값을 저
	}
	
	if(listpage != pagecount){
		listing = communityList.subList((listpage-1)*ROWSIZE, listpage*ROWSIZE);
	} else {
		listing = communityList.subList((listpage-1)*ROWSIZE, communityList.size());
	}
	
	int startPage = ((listpage-1)/BLOCK*BLOCK)+1;
	int endPage = ((listpage-1)/BLOCK*BLOCK)+BLOCK;
	
	if(endPage > pagecount) {
		endPage = pagecount;
	}
%>

<!-- Head 삽입 -->
<jsp:include page="/include/head.jsp" />

<body>

	<div id="page-wrapper">

		<!-- Header 삽입 -->
		<jsp:include page="/include/header.jsp" />

		<!-- Nav 삽입 -->
		<jsp:include page="/include/nav.jsp" />

		<!-- Main -->
		<section id="main" class="search">
			<div class="container">
				<div class="col-12">
					<div class="content">
						<article class="box page-content">
							<header>
								<h2>커뮤니티</h2>
							</header>
						</article>
					</div>
					<!-- Highlight -->
					<section class="box highlight search_box mgl50p">
						<table>
							<caption>커뮤니티 게시글 리스트</caption>
							<colgroup>
								<col width="10%" />
								<col width="" />
								<col width="15%" />
								<col width="15%" />
							</colgroup>
							<thead>
								<tr>
									<th>번호</th>
									<th>제목</th>
									<th>작성자</th>
									<th>작성 날짜</th>
								</tr>
							</thead>
							<tbody>
								<%
									for (CommunityVO community : listing) {
								%>
								<tr>
									<td><%=community.getIdx()%></td>
									<td class="tleft"><a href="javascript:void(0);"
										onclick="boardDetail(<%=community.getIdx()%>);"><%=community.getTitle()%></a></td>
									<td><%=community.getAuthor()%></td>
									<td><%=community.getDate()%></td>
								</tr>
								<%
									}
								%>
							</tbody>
						</table>
						<ul class="pagination">
						<% if(listpage > BLOCK) { %>
							<li><a href="/community?page=1">◀◀</a></li>
							<li><a href="/community?page=<%=startPage-1%>">◀</a></li>
						<% } %>
						
						<% 
							for(int i = startPage; i <= endPage; i++) {
								if(i==listpage){
						%>
									<li class="current"><%=i%></li>
								<% } else { %>
									<li><a href="/community?page=<%=i%>"><%=i%></a></li>
								<% } %>
						<% } %>
						
						
						<% if(endPage < pagecount) { %>
							<li><a href="/community?page=<%=endPage+1%>">▶</a></li>
							<li><a href="/community?page=<%=pagecount%>">▶▶</a></li>
						<% } %>
						</ul>
						<ul class="actions">
							<li><a href="./writeForm.jsp" class="button">글 작성</a></li>
						</ul>
					</section>
				</div>

			</div>
		</section>

		<!-- Footer 삽입 -->
		<jsp:include page="/include/footer.jsp" />

	</div>
	<script>
		function boardDetail(idx) {
			location.href = './detail.jsp?idx=' + idx;
		}
	</script>
</body>

</html>