<%@page import="java.security.KeyPair"%>
<%@page import="java.security.PrivateKey"%>
<%@page import="java.security.PublicKey"%>
<%@page import="java.security.KeyFactory"%>
<%@page import="java.security.spec.RSAPublicKeySpec"%>

<%@page import="com.pjt.cstore.common.CipherUtil"%>
<%@page import="java.util.Base64"%>

<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html lang="ko">
<%
	KeyPair keyPair = CipherUtil.genRSAKeyPair();
	
	
	
	PublicKey publicKey = keyPair.getPublic();
	PrivateKey privateKey = keyPair.getPrivate();



	
	//private key는 서버에 보관
	session.setAttribute("privateKey", privateKey);

	KeyFactory keyFactory = KeyFactory.getInstance("RSA");
	
	RSAPublicKeySpec publicSpec =
(RSAPublicKeySpec) keyFactory.getKeySpec(publicKey, RSAPublicKeySpec.class);
	String publicKeyModulus = publicSpec.getModulus().toString(16);
	String publicKeyExponent = publicSpec.getPublicExponent().toString(16);

	
    //public key는 client 에게 전달하기 위해 html 코드에 삽입
	String ceo = (String) session.getAttribute("ceo");
	String user = (String) session.getAttribute("user");
	if (ceo != null && ceo.equals("1")) {
		response.sendRedirect("/ceo");
	}
%>
<!-- Head 삽입 -->
<jsp:include page="/include/head.jsp" />

<body>
	<%
		request.setCharacterEncoding("utf-8");
		String adult = request.getParameter("adult");
		if (adult == null) {
			adult = "0";
		}
	%>
	<div id="page-wrapper">

		<!-- Header 삽입 -->
		<jsp:include page="/include/header.jsp" />

		<!-- Nav 삽입 -->
		<jsp:include page="/include/nav.jsp" />

		<!-- Main -->
		<section id="main">
			<div class="container">
				<div class="col-12">

					<div class="content">

						<!-- Content -->
						<article class="box page-content">

							<header>
								<h2>회원가입</h2>
							</header>

							<!-- Features -->
							<section class="box features">
								<div>
									<form action="/CustomerJoin" method="POST"
										class="form join" id="joinform">
										<div class="row">
											<div class="col-12 row mgt05">
												<label for="name" class="col-3">성명</label> <input
													type="text" id="name" name="name" class="col-6" required />
											</div>
											<div class="col-12 row mgt05">
												<label for="join_id" class="col-3">ID</label> <input
													type="text" id="join_id" name="join_id" class="col-6"
													required />
												<button type="button" onClick="idCheck()"
													class="button col-2 right">중복확인</button>
												<input type="hidden" name="idChecker" value="unCheck">
											</div>
											<div class="col-12 row mgt05">
												<label for="join_password" class="col-3">비밀번호</label> <input
													type="password" id="join_password" name="join_password"
													class="col-6" required />
											</div>
											<div class="col-12 row mgt05">
												<label for="password_Chk" class="col-3">비밀번호 확인</label> <input
													type="password" id="password_Chk" name="password_Chk"
													class="col-6" required />
											</div>
											<div class="col-12 row mgt05">
												<label for="phone" class="col-3">핸드폰</label> <input
													type="text" id="phone" name="phone" class="col-6" maxlength="11" required />
											</div>
											<div class="col-12 row mgt05">
												<label for="address" class="col-3">주소</label> <input
													type="text" id="address" name="address" class="col-6"
													required />
											</div>
											<div class="col-12 row mgt05">
												<label for="detail_address" class="col-3">상세주소</label> <input
													type="text" id="detail_address" name="detail_address"
													class="col-6" required />
											</div>

											<div class="col-12">
												<ul class="actions">
													<li><a href="javascript:history.back()"
														class="button alt">이전</a></li>
													<li><button type="button" id = "gaip_btn" onClick="submitJoin()"
															class="button">가입완료</button></li>
												</ul>
											</div>

										</div>
									</form>
								</div>
							</section>

						</article>

					</div>

				</div>
			</div>
		</section>

		<!-- Footer 삽입 -->
		<jsp:include page="/include/footer.jsp" />
		<script>
			$(document).ready(function() {
				$('.join').append($('<input name="adult" id="adult" style="display:none"/>').val(<%=adult%>));
			});

			function idCheck() {
				var $id = $('#join_id').val();

				if ($id == "") {
					alert('아이디를 입력하세요.');
					return false;
				}

				$.ajax({
					async : true,
					type : 'GET',
					url : "<%=request.getContextPath()%>/idCheck?joinid="+$id,
					dataType : "json",
					contentType : "application/json; charset=UTF-8",
					success : function(data) {
						if (data == 0) {
							alert("아이디가 존재합니다. 다른 아이디를 입력해주세요.");
							$('input[name=idChecker]').val('unCheck');
						} else {
							alert("사용가능한 아이디입니다.");
							$('input[name=idChecker]').val($id);
						}
					}
				});

			}

			function submitJoin() {

				/* 입력 검증 */
				if ($("#name").val() == "") {
					alert('이름을 입력하세요.');
					return false;
				} else if ($("#join_id").val() == "") {
					alert('아이디를 입력하세요.');
					return false;
				} else if ($("#join_password").val() == "") {
					alert('비밀번호를 입력하세요.');
					return false;
				} else if ($("#password_Chk").val() == "") {
					alert('비밀번호 확인을 입력하세요.');
					return false;
				} else if ($("#phone").val() == "") {
					alert('핸드폰을 입력하세요.');
					return false;
				} else if ($("#address").val() == "") {
					alert('주소를 입력하세요.');
					return false;
				} else if ($("#detail_address").val() == "") {
					alert('상세주소를 입력하세요.');
					return false;
				}
				
				/* 핸드폰 입력 정규식 검증 */
				var regExp = /(01[016789])([1-9]{1}[0-9]{2,3})([0-9]{4})$/;
				
				if (!regExp.test($("#phone").val())) {
					alert('핸드폰을 입력을 확인하세요.');
					return false;
				}
				
				/* 비밀번호, 비밀번호 확인 검증 */
				if($("#join_password").val() != $("#password_Chk").val()) {
					alert('비밀번호 확인이 옳지 않습니다.');
					return false;
				}
				
				/* 아이디 중복확인 검증 */
				if($("#join_id").val() != $('input[name=idChecker]').val()) {
					alert('아이디 중복 확인을 해주세요.');
					return false;
				}
				
				$("#join_password").val($.md5($("#join_password").val()));
				
				let name = $("#name").val();
				let id = $("#join_id").val();
			    
				let phone = $("#phone").val();
				let address = $("#address").val();
				let detail_address = $("#detail_address").val();
				//let address = $("#address").val().replace(/ /g,"ㅁ");
				//let detail_address = $("#detail_address").val().replace(/ /g,"ㅁ");

				var rsa = new RSAKey();
		        rsa.setPublic("<%= publicKeyModulus%>","<%= publicKeyExponent%>");

		        var id_encrypted = rsa.encrypt(id);
				var name_encrypted = rsa.encrypt(name);
				
				var phone_encrypted = rsa.encrypt(phone);
				var address_encrypted = rsa.encrypt(address);
				var detail_address_encrypted = rsa.encrypt(detail_address);
		        
			        
		        $.ajax({      
		            type:"POST",  
		            url:"<%=request.getContextPath()%>/CustomerJoin",      
		            data:{"name" : name_encrypted, 
		            	  "join_id" : id_encrypted, 
		            	  "join_password" : $("#join_password").val(), 
		            	  "phone" : phone_encrypted,
		            	  "address" : address_encrypted,
		            	  "detail_address" : detail_address_encrypted,
		            	  "adult" : $("#adult").val()},
		            success:function(result){
		            	alert(result);
		            	location.href = '/';
		            }
		            
		        });  

			}
		</script>
	</div>
	
		<script>
  src="https://code.jquery.com/jquery-3.4.1.js"
  integrity="sha256-WpOohJOqMqqyKL9FccASB9O0KwACQJpFTUBLTYOVvVU="
  crossorigin="anonymous"</script>
	<script type="text/javascript" src="<%=request.getContextPath() %>/assets/js/rsa.js"></script>
	<script type="text/javascript" src="<%=request.getContextPath() %>/assets/js/jsbn.js"></script>
	<script type="text/javascript" src="<%=request.getContextPath() %>/assets/js/prng4.js"></script>
	<script type="text/javascript" src="<%=request.getContextPath() %>/assets/js/rng.js"></script>
 
		
	<script>
	$(".gaip_btn").click(function(e){
		e.preventDefault();
		

	});
	</script>
</body>

</html>