<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="com.pjt.cstore.StoreDAO"%>
<%@page import="com.pjt.cstore.StoreVO"%>
<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html lang="ko">
<%
	String user = (String) session.getAttribute("user");
	
	StoreDAO storeDAO = new StoreDAO();
	ArrayList<StoreVO> storeList = null;
	List<StoreVO> listing = null;
	storeList = storeDAO.onlyfavoritelist(user);
	
	// 페이지네이션 관련 소스
	final int ROWSIZE = 6; // 한페이지에 보일 게시물 수
	final int BLOCK = 5; // 아래에 보일 페이지 최대개수
	int pagecount = 0;
	
	if(storeList.size() != 0){
		pagecount = storeList.size()/ROWSIZE + 1; // 총 페이지 개수
		
		if(storeList.size()%ROWSIZE == 0) {
			pagecount -= 1;
		}
	}
	
	int listpage = 1; //기본 페이지값
	if (request.getParameter("page") != null) { //받아온 pg값이 있을때, 다른페이지일때
		listpage = Integer.parseInt(request.getParameter("page")); // pg값을 저
	}
	
	if(listpage != pagecount){
		listing = storeList.subList((listpage-1)*ROWSIZE, listpage*ROWSIZE);
	} else {
		listing = storeList.subList((listpage-1)*ROWSIZE, storeList.size());
	}
	
	int startPage = ((listpage-1)/BLOCK*BLOCK)+1;
	int endPage = ((listpage-1)/BLOCK*BLOCK)+BLOCK;
	
	if(endPage > pagecount) {
		endPage = pagecount;
	}
%>
<!-- Head 삽입 -->
<jsp:include page="/include/head.jsp" />

	<script>
	function locationSet(id, address, name) {
		$('.dim').css('display', 'block');
		var mapContainer = document.getElementById(id), // 지도를 표시할 div 
		mapOption = {
			center : new kakao.maps.LatLng(33.450701, 126.570667), // 지도의 중심좌표
			level : 3
		// 지도의 확대 레벨
		};

		// 지도를 생성합니다    
		var map = new kakao.maps.Map(mapContainer, mapOption);

		// 주소-좌표 변환 객체를 생성합니다
		var geocoder = new kakao.maps.services.Geocoder();

		// 주소로 좌표를 검색합니다
		geocoder
				.addressSearch(
						address,
						function(result, status) {

							// 정상적으로 검색이 완료됐으면 
							if (status === kakao.maps.services.Status.OK) {

								var coords = new kakao.maps.LatLng(
										result[0].y, result[0].x);

								// 결과값으로 받은 위치를 마커로 표시합니다
								var marker = new kakao.maps.Marker({
									map : map,
									position : coords
								});

								// 인포윈도우로 장소에 대한 설명을 표시합니다
								var infowindow = new kakao.maps.InfoWindow(
										{
											content : '<div style="width:150px;text-align:center;padding:6px 0;">'+address+'</div>'
										});
								infowindow.open(map, marker);

								// 지도의 중심을 결과값으로 받은 위치로 이동시킵니다
								map.setCenter(coords);
								$('input[name=locChecker]').val("check");
							}
							
							
						});

	}
	</script>
<body class="homepage is-preload">

	<div id="page-wrapper">

		<!-- Header 삽입 -->
		<jsp:include page="/include/header.jsp" />

		<!-- Nav 삽입 -->
		<jsp:include page="/include/nav.jsp" />

		<!-- Main -->
		<section id="main">
			<div class="container">
				<div class="row p_relative">
					<div class="col-3">
						<div class="sidebar">

							<!-- Sidebar -->

							<!-- Recent Posts -->
							<section>
								<h2 class="major">
									<span>즐겨찾는 점포</span>
								</h2>
							</section>

						</div>
					</div>
					<div class="col-3 f_parent sort">
						<h3 class="fl">
							<span>정렬기준: </span>
						</h3>
						
						<select class="fr sort_standard">
							<option value="none">옵션선택</option>
							<option value="name">가,나,다 순</option>
							<option value="favorite">즐겨찾기 순</option>
						</select>
					</div>
					

					<div class="col-12 itemThumbnail">
						<!-- Features -->
						<section class="box features highlight">
							<div>
								<div class="row">
								
								<%
									for (StoreVO store : listing) {
								%>
								<div class="col-4 col-6-medium col-12-small">
								<!-- Feature -->
										<section class="box feature p_relative">
											<a href="/store/product.jsp?code=<%=store.getCode()%>" class="image featured map" id="map<%=store.getCode()%>"></a>
											<%if(store.getFavorite() == 1) { %>
												<button class="favorite_btn on" onClick="unsave_favorite(<%=store.getCode()%>)">즐겨찾기 해제</button>
											<% } else { %>
												<button class="favorite_btn" onClick="save_favorite(<%=store.getCode()%>)">즐겨찾기</button>
											<% } %>
											<h3>
												<a href="/store/product.jsp?code=<%=store.getCode()%>"><%=store.getName()%></a>
											</h3>
										</section>
								</div>
								<script>
								locationSet("map<%=store.getCode()%>", "<%=store.getAddress()%>", "<%=store.getName()%>");
								</script>
								<%
									}
								%>
								</div>
							</div>
						<% if(storeList.size() != 0) { %>
						<ul class="pagination">
							<% if(listpage > BLOCK) { %>
								<li><a href="#" onclick="page(1)">◀◀</a></li>
								<li><a href="#" onclick="page(<%=startPage-1%>)">◀</a></li>
							<% } %>
							
							<% 
								for(int i = startPage; i <= endPage; i++) {
									if(i==listpage){
							%>
										<li class="current"><%=i%></li>
									<% } else { %>
										<li><a href="#" onclick="page(<%=i%>)"><%=i%></a></li>
									<% } %>
							<% } %>
							
							
							<% if(endPage < pagecount) { %>
								<li><a href="#" onclick="page(<%=endPage+1%>)">▶</a></li>
								<li><a href="#" onclick="page(<%=pagecount%>)">▶▶</a></li>
							<% } %>
						</ul>
						<% } %>
						</section>
					</div>

				</div>
			</div>
		</section>

	</div>

	<!-- Footer 삽입 -->
	<jsp:include page="/include/footer.jsp" />
</body>
<script>
	$(function(){
		$(".sort_standard").on("change",function(){
			if($(this).val() == "favorite"){
				<% if (user == null) { %>
					alert("로그인이 필요합니다.");
				<% } else { %>
					location.href = "/store/index.jsp?sort=favorite";
				<% } %>
			} else {
				location.href = "/store/index.jsp?sort=name";
			}
		});
	});

	function page(page_num) {
		var cur_loc = $(location).attr('href');
		cur_loc = cur_loc.replace('#','');
		cur_loc = cur_loc.split('&page');
		cur_loc = cur_loc[0].split('?page');
		var loc = cur_loc[0];
		if(loc.indexOf('?') != -1){
			location.href = loc + "&page=" + page_num;
		} else {
			location.href = loc + "?page=" + page_num;
		}
	}
	
	function save_favorite(code) {
		<% if (user == null) { %>
		alert("로그인이 필요합니다.");
		<% } else { %>
		$.ajax({
			async : true,
			type : 'GET',
			url : "/StoreController?code="+code+"&id=<%=user%>&type=savefavorite",
			dataType : "text",
			contentType : "application/json; charset=UTF-8",
			success : function(data) {
				if(data == "success") {
					location.reload();
				}
			}
		});
		<% } %>
	}
	
	function unsave_favorite(code) {
		<% if (user == null) { %>
		alert("로그인이 필요합니다.");
		<% } else { %>
		$.ajax({
			async : true,
			type : 'GET',
			url : "/StoreController?code="+code+"&id=<%=user%>&type=unsavefavorite",
			dataType : "text",
			contentType : "application/json; charset=UTF-8",
			success : function(data) {
				if(data == "success") {
					location.reload();
				}
			}
		});
		<% } %>
	}
</script>
</html>