<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="com.pjt.cstore.ProductDAO"%>
<%@page import="com.pjt.cstore.ProductVO"%>
<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html lang="ko">
<%
	String user = (String) session.getAttribute("user");
	
	ProductDAO productDAO = new ProductDAO();
	ArrayList<ProductVO> productList = null;
	List<ProductVO> listing = null;
	
	productList = productDAO.newlylist(user);
	
	// 페이지네이션 관련 소스
	final int ROWSIZE = 6; // 한페이지에 보일 게시물 수
	final int BLOCK = 5; // 아래에 보일 페이지 최대개수
	int pagecount = 0;
	int listpage = 0;
	int startPage = 0;
	int endPage = 0;
	if(productList.size() != 0){
		pagecount = productList.size()/ROWSIZE + 1; // 총 페이지 개수
		
		if(productList.size()%ROWSIZE == 0) {
			pagecount -= 1;
		}
	
	
		listpage = 1; //기본 페이지값
		if (request.getParameter("page") != null) { //받아온 pg값이 있을때, 다른페이지일때
			listpage = Integer.parseInt(request.getParameter("page")); // pg값을 저
		}
		
		if(listpage != pagecount){
			listing = productList.subList((listpage-1)*ROWSIZE, listpage*ROWSIZE);
		} else {
			listing = productList.subList((listpage-1)*ROWSIZE, productList.size());
		}
		
		startPage = ((listpage-1)/BLOCK*BLOCK)+1;
		endPage = ((listpage-1)/BLOCK*BLOCK)+BLOCK;
		
		if(endPage > pagecount) {
			endPage = pagecount;
		}
	}
%>
<!-- Head 삽입 -->
<jsp:include page="/include/head.jsp" />
<body class="homepage is-preload">

	<div id="page-wrapper">

		<!-- Header 삽입 -->
		<jsp:include page="/include/header.jsp" />

		<!-- Nav 삽입 -->
		<jsp:include page="/include/nav.jsp" />

		<!-- Main -->
		<section id="main">
			<div class="container">
				<div class="row p_relative">
					<div class="col-3">
						<div class="sidebar">

							<!-- Sidebar -->

							<!-- Recent Posts -->
							<section>
								<h2 class="major">
									<span>상품목록</span>
								</h2>
							</section>

						</div>
					</div>
					<div class="col-3 f_parent sort">
						<h3 class="fl">
							<span>정렬기준: </span>
						</h3>
						
						<select class="fr sort_standard">
							<option value="none">옵션선택</option>
							<option value="name">가,나,다 순</option>
							<option value="favorite">즐겨찾기 순</option>
						</select>
					</div>
					

					<div class="col-12 itemThumbnail">
						<!-- Features -->
						<section class="box features highlight">
							<div>
								<div class="row">
								
								
								<% if(productList.size() != 0) { %>
									<%									
										for (ProductVO product : listing) {
									%>
									<div class="col-4 col-6-medium col-12-small">
									<!-- Feature -->
											<section class="box feature p_relative">
												<a href="/store/productdetail.jsp?code=<%=product.getCode()%>&setcode=<%=product.getSetcode()%>" class="image featured map">
													<img class="product" src="/assets/img/<%=product.getImg()%>" alt="<%=product.getName()%>" />
												</a>
												<%if(product.getFavorite() == 1) { %>
													<button class="favorite_btn on" onClick="unsave_favorite('<%=product.getCode()%>','<%=product.getSetcode()%>')">즐겨찾기 해제</button>
												<% } else { %>
													<button class="favorite_btn" onClick="save_favorite('<%=product.getCode()%>','<%=product.getSetcode()%>')">즐겨찾기</button>
												<% } %>
												<h3>
													<a href="#"><%=product.getName()%></a>
												</h3>
											</section>
									</div>
									<%
										}
									%>
								<% } %>
								</div>
							</div>
						<% if(productList.size() != 0) { %>
						<ul class="pagination">
							<% if(listpage > BLOCK) { %>
								<li><a href="#" onclick="page(1)">◀◀</a></li>
								<li><a href="#" onclick="page(<%=startPage-1%>)">◀</a></li>
							<% } %>
							
							<% 
								for(int i = startPage; i <= endPage; i++) {
									if(i==listpage){
							%>
										<li class="current"><%=i%></li>
									<% } else { %>
										<li><a href="#" onclick="page(<%=i%>)"><%=i%></a></li>
									<% } %>
							<% } %>
							
							
							<% if(endPage < pagecount) { %>
								<li><a href="#" onclick="page(<%=endPage+1%>)">▶</a></li>
								<li><a href="#" onclick="page(<%=pagecount%>)">▶▶</a></li>
							<% } %>
						</ul>
						<% } %>
						</section>
					</div>

				</div>
			</div>
		</section>

	</div>

	<!-- Footer 삽입 -->
	<jsp:include page="/include/footer.jsp" />
</body>
<script>
	$(function(){
		$(".sort_standard").on("change",function(){
			if($(this).val() == "favorite"){
				<% if (user == null) { %>
					alert("로그인이 필요합니다.");
				<% } else { %>
					location.href = "/store/product.jsp?sort=favorite&code=<%=request.getParameter("code")%>";
				<% } %>
			} else {
				location.href = "/store/product.jsp?sort=name&code=<%=request.getParameter("code")%>";
			}
		});
		
		$(".page_1").attr("href", cur_loc+"&page=1");
	});

	function page(page_num) {
		var cur_loc = $(location).attr('href');
		cur_loc = cur_loc.replace('#','');
		cur_loc = cur_loc.split('&page');
		cur_loc = cur_loc[0].split('?page');
		var loc = cur_loc[0];
		if(loc.indexOf('?') != -1){
			location.href = loc + "&page=" + page_num;
		} else {
			location.href = loc + "?page=" + page_num;
		}
	}
	
	function save_favorite(code,setCode) {
		<% if (user == null) { %>
		alert("로그인이 필요합니다.");
		<% } else { %>
		$.ajax({
			async : true,
			type : 'GET',
			url : "/ProductController?code=" + code + "&id=<%=user%>&type=savefavorite&setCode=" + setCode,
			dataType : "text",
			contentType : "application/json; charset=UTF-8",
			success : function(data) {
				if(data == "success") {
					location.reload();
				}
			}
		});
		<% } %>
	}
	
	function unsave_favorite(code,setCode) {
		<% if (user == null) { %>
		alert("로그인이 필요합니다.");
		<% } else { %>
		$.ajax({
			async : true,
			type : 'GET',
			url : "/ProductController?code="+code+"&id=<%=user%>&type=unsavefavorite&setCode=" + setCode,
			dataType : "text",
			contentType : "application/json; charset=UTF-8",
			success : function(data) {
				if(data == "success") {
					location.reload();
				}
			}
		});
		<% } %>
	}
</script>
</html>